//global window, GS, document, evt

window.addEventListener('keydown', function (event) {
    if (event.altKey) {
        event.preventDefault();
    }
});

var bolSettingsLoaded = true;

function refreshButtons(bolBtnType) {
    'use strict';
    var curr_toolbar, curr_tab_num, tabElement, bolBtnLabeled;
    if (bolBtnType === '' ||
        bolBtnType === undefined ||
        bolBtnType === null ||
        bolBtnType === 'undefined' ||
        bolBtnType === 'null') {
        bolBtnLabeled = true;
    } else {
        bolBtnLabeled = bolBtnType;
    }
    jsnConfig.labeledButtons = bolBtnLabeled;
    if (bolBtnLabeled === 'false' || bolBtnLabeled === false) {
        // set to unlabeled buttons
        for (var i = 0, len = xtag.query(document.body, '.tab-button').length; i < len; i += 1) {
            curr_toolbar = xtag.query(document.body, '.tab-button')[i];
            if (curr_toolbar.relatedEditorToolbar) {
                curr_tab_num = curr_toolbar.relatedEditorToolbar.id.substring(parseInt(curr_toolbar.relatedEditorToolbar.id.lastIndexOf('-'), 10) + 1, curr_toolbar.relatedEditorToolbar.id.length);

                document.getElementById('sql-ace-toolbar-' + curr_tab_num + '').classList.add('ace-toolbar-unlabeled');
                document.getElementById('sql-ace-toolbar-' + curr_tab_num + '').classList.remove('ace-toolbar-labeled');
            }
        }
    } else {
        // set to labeled buttons
        for (var i = 0, len = xtag.query(document.body, '.tab-button').length; i < len; i += 1) {
            curr_toolbar = xtag.query(document.body, '.tab-button')[i];
            if (curr_toolbar.relatedEditorToolbar) {
                curr_tab_num = curr_toolbar.relatedEditorToolbar.id.substring(parseInt(curr_toolbar.relatedEditorToolbar.id.lastIndexOf('-'), 10) + 1, curr_toolbar.relatedEditorToolbar.id.length);

                document.getElementById('sql-ace-toolbar-' + curr_tab_num + '').classList.remove('ace-toolbar-unlabeled');
                document.getElementById('sql-ace-toolbar-' + curr_tab_num + '').classList.add('ace-toolbar-labeled');
            }
        }
    // console.log(xtag.query(document.body, '.current-tab')[0].relatedEditorToolbar.parentElement);
    }
}

function refreshCustomCSS (customCSS) {
    'use strict';
    var customCSSText;
    if (customCSS === '' ||
        customCSS === undefined ||
        customCSS === null ||
        customCSS === 'undefined' ||
        customCSS === 'null') {
//        customCSSText = '\n\n\n\n\n';
        customCSSText = ml(function () {/*
/* Default SQL Results CSS * /
.sql-results-area {
	word-wrap: break-word;
	text-align: left;
	color: #333;
	font-family: Helvetica,Arial,sans-serif;
	font-size: 14px;
	line-height: 1.42857;
}

/* Monospace SQL Results CSS, Uncomment to Activate * /
/*
.sql-results-area {
	word-wrap: break-word;
	text-align: left;
	color: #333;
	font-family: "Monaco","Menlo","Ubuntu Mono","Consolas","source-code-pro",monospace;
	font-feature-settings: normal;
	font-kerning: auto;
	font-language-override: normal;
	font-size: 11.2px;
	font-size-adjust: none;
	font-stretch: normal;
	font-style: normal;
	font-synthesis: weight style;
	font-variant: normal;
	font-variant-alternates: normal;
	font-variant-caps: normal;
	font-variant-east-asian: normal;
	font-variant-ligatures: normal;
	font-variant-numeric: normal;
	font-variant-position: normal;
	font-weight: 400;
}
* /
*/}).replace(/\* \//g, '*/');
    } else {
        customCSSText = customCSS;
    }
    jsnConfig.customCSS = customCSSText;
    var CSSElements = document.getElementsByClassName('customCss');
    // for (var i = 0, len = CSSElements.length; i < len; i++) {
    //     console.log(CSSElements);
    //     CSSElements[i].innerHTML = customCSSText;
    // }
    document.getElementById('customCss').innerHTML = customCSSText;
    //GS.triggerEvent(window, 'resize');
}


function refreshCustomSnippets (customSnippets) {
    'use strict';
    var customSnippetText;
    if (customSnippets === '' ||
    customSnippets === undefined ||
        customSnippets === null ||
        customSnippets === 'undefined' ||
        customSnippets === 'null') {
        customSnippetText = '//     snippets are in a modified textmate format, more info:\n' +
                '//          http://blog.macromates.com/2005/the-power-of-snippets/\n' +
                '\n' +
                '//     Basics of the format:\n' +
                '//     to place a cursor: ${1}\n' +
                '//     to place a cursor around text: ${1:text to replace}\n' +
                '//     once the snippet is used, tab will move you between the tokens in numerical order.\n' +
                '\n' +
                '//     Example:\n' +
                '//     snippets.push([\'CREATE VIEW (Snippet)\', \'SQLSnippet\', ml(function () {/*CREATE OR REPLACE VIEW ${1:schema}.${2:view} AS\n' +
                '//    	${3}\n' +
                '//     \n' +
                '//     ALTER TABLE ${1:schema}.${2:view} OWNER TO postgres;\n' +
                '//     GRANT SELECT,UPDATE,INSERT,DELETE,TRUNCATE,REFERENCES,TRIGGER ON TABLE ${1:schema}.${2:view} TO ${4:envelope_g};\n' +
                '//     * /})]);\n' +
                '\n' +
                '//     Add in your own snippets below, then close the options page and refresh with [CMD-R] shortcut on Mac, [CTRL-R] on Windows.\n' +
                '\n' +
                '\n' +
                '\n';
    } else {
        customSnippetText = customSnippets;
    }
    jsnConfig.customPostgresSnippets = customSnippetText;
    // document.getElementById('customSnippets').innerHTML = customSnippetText;
    // console.log(document.getElementById('customSnippets').innerHTML);
    eval(customSnippetText);
}

window.addEventListener('user-data-loaded', function () {
    refreshCustomCSS(jsnConfig.customCSS);
    if (window.bolSnippetsLoaded) {
        refreshCustomSnippets(jsnConfig.customPostgresSnippets);
    } else {
        window.addEventListener('snippetRegister', function () {
            refreshCustomSnippets(jsnConfig.customPostgresSnippets);
        });
    }
});




function refreshShortcutKeys (shortcutKeys) {
    'use strict';
    var shortcutKeysText = [];
    if (window.navigator.userAgent.toLowerCase().indexOf('macintosh') !== -1) {
        var CTRLCMD = 'Command';
    } else {
        var CTRLCMD = 'Control';
    }
    if (!shortcutKeys) {
        shortcutKeysText = [
              [CTRLCMD,     'o',       'ShortcutNewTab']
            , ['',          'F7',      'ShortcutExplain']
            , ['Shift',     'F7',      'ShortcutExplainAnalyze']
            , ['',          'F5',      'ShortcutRunQuery']
            , [CTRLCMD,     's',       'ShortcutSave']
            , [CTRLCMD,     '.',       'ShortcutDocs']
            , ['',          'Escape',  'ShortcutHome']
            , [CTRLCMD,     'Enter',   'ShortcutRunCursorQuery']
        ];
    } else {
        shortcutKeysText = shortcutKeys;
    }
    jsnConfig.ShortcutNewTab = shortcutKeysText[0];
    jsnConfig.ShortcutExplain = shortcutKeysText[1];
    jsnConfig.ShortcutExplainAnalyze = shortcutKeysText[2];
    jsnConfig.ShortcutRunQuery = shortcutKeysText[3];
    jsnConfig.ShortcutSave = shortcutKeysText[4];
    jsnConfig.ShortcutDocs = shortcutKeysText[5];
    jsnConfig.ShortcutHome = shortcutKeysText[6];
    jsnConfig.ShortcutRunCursorQuery = shortcutKeysText[7];
    // var strScript, thisArrText;
    // var keydownShortcuts = '';
    // //strScript = 'function keydownShortcuts (event) {;\n';
    // strScript = 'document.addEventListener("keydown", keydownShortcuts = function (event) {\n';

    // for (var i = 0, len = shortcutKeysText.length; i < len; i++) {
    //     thisArrText = shortcutKeysText[i];
    //     console.log(thisArrText);
    //     strScript += '    if (event.key === "' + thisArrText[1] + '"';
    //     if (thisArrText[0] === 'Command') {
    //         strScript += ' && event.metaKey) {\n';
    //     } else if (thisArrText[0] === 'Control') {
    //         strScript += ' && event.ctrlKey) {\n';
    //     } else if (thisArrText[0] === 'Option') {
    //         strScript += ' && event.altKey) {\n';
    //     } else if (thisArrText[0] === 'Shift') {
    //         strScript += ' && event.shiftKey) {\n';
    //     } else {
    //         strScript += ') {\n';
    //     }
    //     strScript += '        ' + thisArrText[2] + '();\n';
    //     strScript += '    }\n';
    // }
    // strScript += '});\n\n';

    // strScript += "document.addEventListener('keydown', keydownShortcuts(event));\n";
    // document.getElementById('shortcutKeys').innerHTML = strScript;
}

document.addEventListener('keydown', function (event) {
    var tabBarElement;
    var tabElement;
    // console.log(event, jsnConfig.ShortcutRunQuery, keyCodeCheck(event, jsnConfig.ShortcutRunQuery));
    if (keyCodeCheck(event, jsnConfig.ShortcutNewTab)) {
        ShortcutNewTab();
    } else if (keyCodeCheck(event, jsnConfig.ShortcutExplainAnalyze)) {
        ShortcutExplainAnalyze();
    } else if (keyCodeCheck(event, jsnConfig.ShortcutExplain)) {
        ShortcutExplain();
    } else if (keyCodeCheck(event, jsnConfig.ShortcutRunQuery)) {
        tabBarElement = document.getElementById('tab-bar');

        // this file (settings.js) is a general file. this functionality below is
        //      specific to the main postage page (index.html). not all pages have
        //      a tab bar. therefore, don't try to do something in a tab bar if it
        //      doesn't exist.
        if (tabBarElement) {
            tabElement = xtag.queryChildren(tabBarElement, '.current-tab')[0];
            if (tabElement.parentNode) {
                if (tabElement.executedWaitingForKeyup !== true) {
                    tabElement.executedWaitingForKeyup = true;
                    executeScript();
                    event.preventDefault();
                    event.stopPropagation();
                }
            }
        }
    } else if (keyCodeCheck(event, jsnConfig.ShortcutSave)) {
        ShortcutSave();
    } else if (keyCodeCheck(event, jsnConfig.ShortcutRunCursorQuery)) {
        event.preventDefault();
        event.stopPropagation();
        executeScript(true);
    } else if (keyCodeCheck(event, jsnConfig.ShortcutDocs)) {
        ShortcutDocs();
    } else if (keyCodeCheck(event, jsnConfig.ShortcutHome)) {
        ShortcutHome();
    }/* else if ((event.metaKey || event.ctrlKey) && event.key === 'w') {
		console.log('test');
		event.preventDefault();
		event.stopPropagation();
    }*/
});

document.addEventListener('keyup', function (event) {
    var tabBarElement = document.getElementById('tab-bar');
    var tabElement;

    if (keyCodeCheck(event, jsnConfig.ShortcutRunQuery)) {
        // this file (settings.js) is a general file. this functionality below is
        //      specific to the main postage page (index.html). not all pages have
        //      a tab bar. therefore, don't try to do something in a tab bar if it
        //      doesn't exist.
        if (tabBarElement) {
            tabElement = xtag.queryChildren(tabBarElement, '.current-tab')[0];
            if (tabElement.parentNode) {
                tabElement.executedWaitingForKeyup = false;
                event.preventDefault();
                event.stopPropagation();
            }
        }
    }
});



function keyCodeCheck(event, storage) {
    if (storage[0] === 'Command') {
        if (event.metaKey && event.key.toLowerCase() === storage[1].toLowerCase()) {
            return true;
        } else {
            return false;
        }
    } else if (storage[0] === 'Control') {
        if (event.ctrlKey && event.key.toLowerCase() === storage[1].toLowerCase()) {
            return true;
        } else {
            return false;
        }
    } else if (storage[0] === 'Option') {
        if (event.altKey && event.key.toLowerCase() === storage[1].toLowerCase()) {
            return true;
        } else {
            return false;
        }
    } else if (storage[0] === 'Shift') {
        if (event.shiftKey && event.key.toLowerCase() === storage[1].toLowerCase()) {
            return true;
        } else {
            return false;
        }
    } else {
        if (event.key.toLowerCase() === storage[1].toLowerCase()) {
            return true;
        } else {
            return false;
        }
    }
}



function getShortcuts () {
	try {
        if (window.navigator.userAgent.toLowerCase().indexOf('macintosh') !== -1) {
            var CTRLCMD = 'Command';
        } else {
            var CTRLCMD = 'Control';
        }
        jsnConfig.ShortcutRunCursorQuery = (jsnConfig.ShortcutRunCursorQuery || [CTRLCMD,     'Enter',   'ShortcutRunCursorQuery']);
        var ValKeyNewTab = jsnConfig.ShortcutNewTab[1];
        var ValKeySaveTab = jsnConfig.ShortcutSave[1];
        var ValKeyRunQuery = jsnConfig.ShortcutRunQuery[1];
        var ValKeyRunCursorQuery = jsnConfig.ShortcutRunCursorQuery[1];
        var ValKeyFindDocumentation = jsnConfig.ShortcutDocs[1];
        var ValKeyExplain = jsnConfig.ShortcutExplain[1];
        var ValKeyExplainAnalyze = jsnConfig.ShortcutExplainAnalyze[1];
        var ValKeyHome = jsnConfig.ShortcutHome[1];

        var ValMetaKeyNewTab = jsnConfig.ShortcutNewTab[0];
        var ValMetaKeySaveTab = jsnConfig.ShortcutSave[0];
        var ValMetaKeyRunQuery = jsnConfig.ShortcutRunQuery[0];
        var ValMetaKeyRunCursorQuery = jsnConfig.ShortcutRunCursorQuery[0];
        var ValMetaKeyFindDocumentation = jsnConfig.ShortcutDocs[0];
        var ValMetaKeyExplain = jsnConfig.ShortcutExplain[0];
        var ValMetaKeyExplainAnalyze = jsnConfig.ShortcutExplainAnalyze[0];
        var ValMetaKeyHome = jsnConfig.ShortcutHome[0];


	    var ShortcutKeysText = [
	          [ValMetaKeyNewTab              ,     ValKeyNewTab,             'ShortcutNewTab']
	        , [ValMetaKeyExplain             ,     ValKeyExplain,            'ShortcutExplain']
	        , [ValMetaKeyExplainAnalyze      ,     ValKeyExplainAnalyze,     'ShortcutExplainAnalyze']
	        , [ValMetaKeyRunQuery            ,     ValKeyRunQuery,           'ShortcutRunQuery']
	        , [ValMetaKeySaveTab             ,     ValKeySaveTab,            'ShortcutSave']
	        , [ValMetaKeyFindDocumentation   ,     ValKeyFindDocumentation,  'ShortcutDocs']
	        , [ValMetaKeyHome                ,     ValKeyHome,               'ShortcutHome']
	        , [ValMetaKeyRunCursorQuery            ,     ValKeyRunCursorQuery,           'ShortcutRunCursorQuery']
	    ];

	    return ShortcutKeysText;
	} catch (e) {
		return undefined;
	}
}
